﻿Ext.namespace("Ext.techbug");


//공통으로 사용되는 트리메뉴
Ext.techbug.TreeMenu = function(config){
	Ext.apply(this,config);
	Ext.techbug.TreeMenu.superclass.constructor.call(this,{
		loader: new Ext.tree.TreeLoader({
			dataUrl:'menu.js', 
			baseParams: { }
		}),
		rootVisible:true,
		lines:true,
		autoScroll:true,
		root: new Ext.tree.AsyncTreeNode({
			id:'_MENU_PANEL_',
			text:'트리메뉴의 Root',
			draggable:false,
			expanded:true
		})
	})
};
Ext.extend(Ext.techbug.TreeMenu, Ext.tree.TreePanel,{ });







//공통으로 사용되는 프로퍼티그리드
Ext.techbug.PropertyGrid = function(config){
	Ext.apply(this,config);
	Ext.techbug.PropertyGrid.superclass.constructor.call(this,{
                    source: {
                        "(name)": "Properties Grid",
                        "grouping": false,
                        "autoFitColumns": true,
                        "productionQuality": false,
                        "created": new Date(Date.parse('10/15/2006')),
                        "tested": false,
                        "version": .01,
                        "borderWidth": 1
                    }
	})
};
Ext.extend(Ext.techbug.PropertyGrid, Ext.grid.PropertyGrid,{ });








//공통으로 사용되는 폼패널
Ext.techbug.TestForm = function(config){
	Ext.apply(this,config);

	Ext.techbug.TestForm.superclass.constructor.call(this,{
  		labelAlign:'top',
		labelWidth:60,
		autoScroll: false,
	        items: [
			{
					xtype:'fieldset',
					checkboxToggle:true,
					title: '사용자정보',
					autoHeight:true,
					defaults: {anchor:'98%'},
					defaultType: 'textfield',
					collapsed: true,
					items :[{
					        fieldLabel: 'First Name',
					        name: 'first',
					        allowBlank:false
					    },{
					        fieldLabel: 'Last Name',
					        name: 'last'
					    },{
					        fieldLabel: 'Company',
					        name: 'company'
					    }, {
					        fieldLabel: 'Email',
					        name: 'email',
					        vtype:'email'
					    }
					]
			},
			{
				xtype:'fieldset',
				title: '연락처',
				collapsible: true,
				autoHeight:true,
				defaults: {width: 210},
				defaultType: 'textfield',
				collapsed: true,
				items :[{
					fieldLabel: 'Home',
					name: 'home',
					value: '(888) 555-1212'
					},{
					fieldLabel: 'Business',
					name: 'business'
					},{
					fieldLabel: 'Mobile',
					name: 'mobile'
					},{
					fieldLabel: 'Fax',
					name: 'fax'
					}
				]	
			},
			{
				xtype:'htmleditor',
				layout:'fit',
				fieldLabel:'Biography',
				height:200,
				anchor:'100%'
			}
		]
	})
};
Ext.extend(Ext.techbug.TestForm, Ext.FormPanel,{ });






//공통으로 사용하는 그리드 샘플
Ext.techbug.GridSample = function(config){
	Ext.apply(this,config);

	this.store = new Ext.data.Store({
		proxy: new Ext.data.HttpProxy({
			url:'basicGrid.json'
		}),
		sortInfo : {
			field : 'price',
			direction : "DESC"
		},
		reader: new Ext.data.JsonReader(
			{ root: 'testData'  },
			[
				{name: 'company', type:'string', mapping: 'company'},
				{name: 'price', type: 'float', mapping: 'price'},
				{name: 'change', type: 'float', mapping: 'change'},
				{name: 'pctChange', type: 'float', mapping: 'pctChange'},
				{name: 'lastChange', type: 'date', dateFormat: 'n/j h:ia', mapping: 'lastChange'}
			]
		)
	});

	Ext.techbug.GridSample.superclass.constructor.call(this,{
		store: this.store,
		columns: [
			{id:'company',header: "Company", width: 160, sortable: true, dataIndex: 'company' },
			{header: "Price", width: 75, sortable: true, renderer: 'usMoney', dataIndex: 'price' },
			{header: "Change", width: 75, sortable: true, dataIndex: 'change'},
			{header: "% Change", width: 75, sortable: true, dataIndex: 'pctChange'},
			{header: "Last Updated", width: 85, sortable: true, renderer: Ext.util.Format.dateRenderer('m/d/Y'), dataIndex: 'lastChange'}
		],
		stripeRows: true,
		autoExpandColumn: 'company',
		loadMask: {msg:'데이타 로드중'},
		sm: new Ext.grid.RowSelectionModel({
			singleSelect:true
		}),
		view: new Ext.grid.GridView({
			forceFit:true,
			enableRowBody:true,
			emptyText: 'No Record found'
		})
	});
};

Ext.extend(Ext.techbug.GridSample, Ext.grid.GridPanel,{
	loadGridDataSet:function(){
		this.store.load();	
	}

 });